library ieee;
use ieee.std_logic_1164.all;
use IEEE.Numeric_Std.all;

-- Declaro la entitat
entity ALU is
    port (SEL : in std_logic_vector(3 downto 0);
        A, B : in std_logic_vector(4 downto 0);
        S1,S2,S3,S4 : out std_logic_vector(6 downto 0);
        L : out std_logic_vector(9 downto 0));
end ALU;
architecture RTL1 of ALU is
    --signal S : std_logic_vector(9 downto 0);

begin
    process (SEL, A, B) is
        variable S : std_logic_vector(9 downto 0);

    begin
        S:="0000000000";
        S1<="0000000";
        S2<="0000000";
        S3<="0000000";
        S4<="0000000";
        L<="0000000000";
        case SEL is
            when "0001" =>
                if A<B then
                    S1 <= "1101111";--g
                    S2 <= "1010000";--r
                elsif A=B then
                    S1 <= "1100111";--q
                    S2 <= "1111001";--E
                else
                    S1 <= "1101111";--g
                    S2 <= "0111000";--L
                end if;
            when "0010" =>
                L <= std_logic_vector("00000" & signed(A) + signed(B));
            when "0100" =>
                S := std_logic_vector("00000" & signed(A)-signed(B));
                if S(9) = '1' then
                    S := std_logic_vector(signed(not S)+1);
                    S1<="1000000";
                end if;
                L <= S;
            when "1000" =>
                L <= std_logic_vector("00000" & signed(A) sll to_integer(unsigned(B)));
            when others =>
            S1<="1010000";--r
            S2<="1010000";--r
            S3<="1111001";--E
        end case;
    end process;
end RTL1;