library IEEE;
use IEEE.STD_LOGIC_1164.all;
entity ALU_TB is
end;
architecture BENCH of ALU_TB is
    signal SEL : std_logic_vector(3 downto 0);
    signal A, B : std_logic_vector(4 downto 0);
    signal S1,S2,S3,S4 : std_logic_vector(6 downto 0);
    signal L : std_logic_vector(9 downto 0);
begin
    M: entity work.ALU(RTL1) port map (
        SEL => SEL,
        A => A,
        B => B,
        S1 =>S1,
        S2 => S2,
        S3 => S3,
        S4 => S4,
        L => L
        );
    process
    begin
    SEL <= "0000";
    wait for 10 NS;    
    
    SEL <= "0001";
    A <= "00001";
    B <= "00010";
    wait for 10 NS;
    assert S1="1101111" and S2="1010000" report "Incorrecte";

    SEL <= "0010";
    wait for 10 NS;
    assert L="0000000011" report "Incorrecte";

    SEL <= "0100";
    wait for 10 NS;
    assert L="0000000001" and  S1="1000000" report "Incorrecte";

    A <= "00010";
    B <= "00001";
    wait for 10 NS;
    assert L="0000000001" and  S1="0000000" report "Incorrecte";

    SEL <= "1000";
    wait for 10 NS;
    assert L="0000000100" report "Incorrecte";

    SEL <= "0001";
    A <= "00001";
    B <= "00001";
    wait for 10 NS;
    assert S1="1100111" and S2="1111001" report "Incorrecte";

    SEL <= "0001";
    A <= "00011";
    B <= "00001";
    wait for 10 NS;
    assert S1="1101111" and S2="0111000" report "Incorrecte";
   
    wait;
    end process;
end BENCH;